/************************************************************************************/
/*  Program name CAPAPEXT_AP_BANK_AC_USE.sql                                        */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
set verify off;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPEXT_AP_BANK_AC_USE';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPAP_AP_BANK_AC_USE.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_SOB_SName	VARCHAR2(100);
	lv_SOB_Count	NUMBER;

	CURSOR Cur_F(p_NGO_SOB VARCHAR2) IS
	SELECT
		S.*,
		A.Bank_Account_Name
	FROM
		GL_SETS_OF_BOOKS			B,
		AP_BANK_ACCOUNTS_ALL		A,
		AP_BANK_ACCOUNT_USES_ALL	S
	WHERE	B.Short_Name		=	p_NGO_SOB
	AND		B.Set_Of_Books_ID	=	A.Set_Of_Books_ID
	AND		A.Account_Type		=	'SUPPLIER'
	AND		A.Bank_Account_ID	=	S.External_Bank_Account_ID;

BEGIN
	lv_SOB_SName	:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_SOB_Count
	FROM	GL_SETS_OF_BOOKS
	WHERE	UPPER(Short_Name)	=	lv_SOB_SName;

	IF	lv_SOB_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_SOB_SName) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Bank_Account_Uses_ID||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Customer_ID||CHR(9)||
				C1.Customer_Site_Use_ID||CHR(9)||
					C1.Vendor_ID||CHR(9)||
					C1.Vendor_Site_ID||CHR(9)||
					C1.External_Bank_Account_ID||CHR(9)||
				C1.Start_Date||CHR(9)||
				C1.End_Date||CHR(9)||
				C1.Primary_Flag||CHR(9)||
				C1.Attribute_Category||CHR(9)||
				C1.Attribute1||CHR(9)||
				C1.Attribute2||CHR(9)||
				C1.Attribute3||CHR(9)||
				C1.Attribute4||CHR(9)||
				C1.Attribute5||CHR(9)||
				C1.Attribute6||CHR(9)||
				C1.Attribute7||CHR(9)||
				C1.Attribute8||CHR(9)||
				C1.Attribute9||CHR(9)||
				C1.Attribute10||CHR(9)||
				C1.Attribute11||CHR(9)||
				C1.Attribute12||CHR(9)||
				C1.Attribute13||CHR(9)||
				C1.Attribute14||CHR(9)||
				C1.Attribute15||CHR(9)||
				C1.Request_ID||CHR(9)||
				C1.Program_Application_ID||CHR(9)||
				C1.Program_ID||CHR(9)||
				C1.Program_Update_Date||CHR(9)||
					C1.Org_ID||CHR(9)||
				C1.Owning_Party_ID||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)||CHR(9)||
				CAPBREXT_COMMON.GetPOVendor(C1.Vendor_ID)||CHR(9)||
				CAPBREXT_COMMON.GetPOVendorSite(C1.Vendor_Site_ID)||CHR(9)||
				C1.Bank_Account_Name||CHR(9)||
				CAPBREXT_COMMON.GetOrgName(C1.Org_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_SOB_SName||': No such set of books exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/